/***************************************************************************
                          stub.cpp  -  Simple Daemon example. This will
						  				create a daemon when it exits, to
										exit, enter "kill `cat /tmp/stub.pid`"
										in a shell (or just killall stub).
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <fstream>

using namespace std;

#include <unistd.h>

#include "daemon.h"

using namespace sucs;

class myProgram: public Daemon
{
protected:
	virtual int RunProgram();
};

int myProgram::RunProgram()
{
	// This is our daemon program entry point (like main())

	// Just record out pid for killing
	ofstream out("/tmp/stub.pid");
	out << getpid() << endl;
	out.close();

	// Then keep touching the running file
	while(1)
	{
		ofstream out("/tmp/stub.running");
		out.close();
		sleep(60);
	}

	// Never get here but I'll put it in anyways
	return 0;
}

int main()
{
	// Declare our daemon
	myProgram theProgram;

	// Daemonise
	theProgram.Daemonise();

	// Only get here if there's an error
	cerr << "Couldn't daemonise! Exiting..." << endl;
	return 1;
}
