//
// C++ Interface: conditionmutex
//
// Description:
//
//
// Author: Gav Wood <gav@indigoarchive.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _SUCS_CONDITIONMUTEX_H
#define _SUCS_CONDITIONMUTEX_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

#ifdef __SUCS
#include "condition.h"
#else
#include <sucs/condition.h>
#endif
using namespace sucs;

namespace sucs
{

/**
@author Gav Wood
*/

class ConditionMutex: private Condition
{
public:
	void signal(bool useMutex = true) const;
	void broadcast(bool useMutex = true) const;
	void lock() const;
	void unlock() const;
	
	/**
	 * Waits for the condition to be signalled/broadcasted.
	 * @param automatic Specifies if the Mutex should be locked/unlocked before/after waiting. If false, it *must*
	 *   be unlocked with unlock() before any more wait()s take place,
	 */
	void wait(bool automatic = true) const;
//	inline bool wait(const Time &time, bool autoUnlock = true);

	ConditionMutex();
	~ConditionMutex();
};

};

#endif
