/***************************************************************************
                          semaphore.h  -  description
                             -------------------
    begin                : Sun Jan 9 2000
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef _SUCS_SEMA
#define _SUCS_SEMA

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

#include <semaphore.h>

namespace sucs
{

class Sema
{
	static int numSemas;
	mutable sem_t theSem;
	int theNumEntries;

public:
	const int semaValue() const;

	void engage() const;
	bool tryWait() const;
	bool wait(bool dontReturnUntilTrue = true) const;
	void signal() const;
	void hop() const;
	
	const Sema &operator++() const;
	const Sema &operator++(int) const { return operator++(); }
	const Sema &operator--() const;
	const Sema &operator--(int) const { return operator--(); }

	void init(int Entries);

	Sema &operator= (const Sema &copy) { init(copy.theNumEntries); return *this; }
	operator int() const;

	Sema(int numEntries = 1);
	Sema(const Sema &newSema);
	~Sema();
};

}

#endif
