/***************************************************************************
                          stub.cpp  -  Example code for training a Kohonen
						  				network
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

#include "kohonennet.h"
#include "kohonendata.h"

using namespace sucs;

int main(int argc, char **argv)
{
	KohonenNet myNet;
	KohonenData myTrain, myTest;

	myNet.Init(4, 4, 11, 0, 1);
	ifstream tin("/home/emmCee/kohonen/training.dat");
	myTrain.readDat(tin);
	tin.close();
	ifstream din("/home/emmCee/kohonen/testing.dat");
	myTest.readDat(din);
	din.close();

	cerr << "Training..." << endl;
	myNet.Train(10000, 0.3, 4, 0.2, myTrain);
	cerr << "Labeling..." << endl;
	myNet.Label(0, 1, myTrain);
	cerr << "Classifying..." << endl;
	myTest.setClassifier(myNet);
	for(unsigned i = 0; i < myTest.getCount(); i++)
		cerr << myTest.getLabel(i) << " => " << myTest.getClass(i) << endl;
}
