/***************************************************************************
                          datatools.h  -  description
                             -------------------
    begin                : Thu Jan 13 2004
    copyright            : (C) 2004 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef _SUCS_CLEANER_H
#define _SUCS_CLEANER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <vector>
using namespace std;

#include "thread.h"
#include "sema.h"
using namespace sucs;

namespace sucs
{

template<class X>
class Cleaner: public Thread, private Sema
{
	vector<X *> theRow;
	int theInterval;
	
	void purgeAll()
	{
		wait();
		for(int i = 0; i < theRow.size(); i++)
			delete theRow[i];
		theRow.clear();
		signal();
	}

protected:
	void ghost() {}

	void body()
	{
		while(1)
		{	sleep(theInterval);
			purgeAll();
		}
	}

public:
	void deleteObject(X *theObject)
	{
		wait();
		theRow.push_back(theObject);
		signal();
	}
	
	Cleaner(int interval = 3): Thread("Cleaner")
	{
		theInterval = interval;
		start();
	}
	
	~Cleaner()
	{
		wait();
		for(int i = 0; i < theRow.size(); i++)
			delete theRow[i];
		theRow.clear();
		cancel();
		waitForDeath();
	}
};

};

#endif
