/***************************************************************************
                          regexp.h  -  description
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef __REGEXP
#define __REGEXP

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

#include <string>

using namespace std;

#include <pcre.h>

namespace sucs
{

class RegExp
{
	pcre *theRegExp;
	const char *LastErrorText;
	int LastErrorOffset;
	
	int *OutVector, OutVectorSize, SubSlots;

	string theExpression, theInput;
	
	void FreeAll();

public:
	void SetExpression(const string &newExpression);
	const bool SetInput(const string &newInput);
	const string Extract(int Index);
	const int GetExtracts() { return SubSlots + 1; }
	
	const bool operator==(const string &newInput) { return SetInput(newInput); }
	const bool operator!=(const string &newInput) { return !SetInput(newInput); }

	inline friend const bool operator==(const string &newInput, RegExp &me) { return me.SetInput(newInput); }
	inline friend const bool operator!=(const string &newInput, RegExp &me) { return !me.SetInput(newInput); }

	const string operator[](int Index) { return Extract(Index); }
	
	RegExp() { theExpression = ""; theInput = ""; }
	RegExp(const string &newExpression) { theExpression = ""; theInput = ""; SetExpression(newExpression); }
	~RegExp() { FreeAll(); }
};

}

#endif
