/***************************************************************************
                          stub.cpp  -  Simple regexp example program
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <string>

using namespace std;

#include "regexp.h"

using namespace sucs;

// Quick & easy getline string function
void getline(istream &in, string &Input)
{
	char Line[80];
	in.getline(Line, 80);
	Input = Line;
}

int main()
{
	string Input;

	cout << "Enter a Perl regular expression: " << flush;
	getline(cin, Input);

	// Declare a regular expression object and define it to be the line input
	RegExp theRegExp(Input);

	while(1)
	{
		cout << "Enter some text ('q' quits): " << flush;
		getline(cin, Input);
		if(Input == "q") break;

		// If the Input matches the RegExp
		if(Input == theRegExp)
		{
			cout << "Matches. Subexpressions are:" << endl;
			for(int i = 1; i < theRegExp.GetExtracts(); i++)
				cout << i << ": " << theRegExp[i] << endl;
		}
		else
			cout << "Does not match the regular expression." << endl;
	}

	return 0;
}
