/***************************************************************************
                          datatools.cpp  -  description
                             -------------------
    begin                : Thu Jan 13 2004
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define __SUCS 1
//#define DEBUG_MESSAGES 1

#include <iostream>
#include <algorithm>
#include <signal.h>
#include <unistd.h>
using namespace std;

#include "thread.h"
#include "signalhandler.h"
#include "signallistener.h"
using namespace sucs;

SignalHandler::SignalHandler(int signal)
{
	theSignals.clear();
	if(signal) handle(signal);
}

SignalHandler::~SignalHandler()
{
	vector<int> bSignals = theSignals;
	for(vector<int>::iterator i = bSignals.begin(); i != bSignals.end(); i++)
		unhandle(*i);
}

// TODO: move most of this code to SignalListener - just need to check that signal is not already handled
// by this. SignalListener will need to check if signal is already handled etc.
// When handled/unhandled, dont forget to update theSignals. SignalListener will update it's own
// data structures.

void SignalHandler::unregister(int signal)
{
	for(vector<int>::iterator i = theSignals.begin(); i != theSignals.end(); i++)
		if(signal == *i)
		{	theSignals.erase(i);
			break;
		}
}

bool SignalHandler::handle(int signal)
{
	if(count(theSignals.begin(), theSignals.end(), signal))
	{	cerr << "handle: Signal " << signal << " already handled by me." << endl << flush;
		return false;
	}
	
	SignalListener::signalListener()->set(signal, this);
	
	theSignals.push_back(signal);
	return true;
}

bool SignalHandler::unhandle(int signal)
{
	if(!count(theSignals.begin(), theSignals.end(), signal))
	{	cerr << "unhandle: Signal " << signal << " is not handled by me (" << this << ")." << endl << flush;
		return false;
	}
	
	SignalListener::signalListener()->reset(signal, this);
	unregister(signal);
	
	return true;
}
