//
// C++ Implementation: threaded
//
// Description:
//
//
// Author: Gav Wood <gav@indigoarchive.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#define __SUCS 1

#undef _SUCS_DEBUG_MESSAGES

#include "threaded.h"

namespace sucs
{

MemberThread::MemberThread(Threaded *parent, const string &name) : Thread(name), theParent(parent)
{
	tdbg("Initialising MemberThread with parent: " << theParent << "." << endl);
	tdbg(theParent << " is really a " << typeid(*theParent).name() << "." << endl);
}

MemberThread::~MemberThread()
{
	tdbg("Destroying MemberThread of " << theParent);
	makeNotRunning();
	tdbg("Destroyed MemberThread of " << theParent);
}

void MemberThread::makeNotRunning()
{
	if(isRunning())
	{	cancel();
		waitForDeath();
	}
}

void MemberThread::setParent(Threaded *parent)
{
	tdbg("Executing setParent on " << this << " from " << theParent << " to " << parent << "..." << endl);
	theParent = parent;
}

void MemberThread::ghost()
{
	tdbg("Executing threadCleanup on " << theParent << "..." << endl);
	tdbg(theParent << " is really a " << typeid(*theParent).name() << "." << endl);
	theParent->threadCleanup(this);
}

void MemberThread::body()
{
	tdbg("Executing threadBody on " << theParent << "..." << endl);
	tdbg(theParent << " is really a " << typeid(*theParent).name() << "." << endl);
	theParent->threadBody(this);
}

};
