//
// C++ Interface: threaded
//
// Description:
//
//
// Author: Gav Wood <gav@indigoarchive.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _SUCS_THREADED_H
#define _SUCS_THREADED_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef __SUCS
#include "thread.h"
#else
#include <sucs/thread.h>
#endif

namespace sucs
{

/**
@author Gav Wood
*/

class MemberThread;

class Threaded
{
	friend class MemberThread;

protected:
	virtual void threadCleanup(MemberThread *exited) = 0;
	virtual void threadBody(MemberThread *started) = 0;
};

class MemberThread: public Thread
{
	Threaded *theParent;

	virtual void ghost();
	virtual void body();

public:
	/**
	 * Use this to adopt a MemberThread.
	 */
	void setParent(Threaded *parent);
	
	/**
	 * Execute this in destructor of parent's class if the threadCleanup accesses
	 * some of classes variables.
	 */
	void makeNotRunning();

	MemberThread(Threaded *parent, const string &name = "");
	virtual ~MemberThread();
};

};

#endif
