/***************************************************************************
                          regexp.h  -  description
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef __XMLPP
#define __XMLPP

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

#include <iostream>
#include <string>
#include <map>

using namespace std;

#include <expat.h>

namespace sucs
{

class XMLReader
{
	XML_Parser theParser;
	bool StripWhite;

	friend void cStartElement(void *userdata, const char *name, const char **atts);
	friend void cEndElement(void *userdata, const char *name);
	friend void cCharData(void *userdata, const XML_Char *s, int len);

protected:
	virtual void StartElement(const string &theName, const map<string, string> &theAttributes) {}
	virtual void EndElement(const string &theName) {}
	virtual void CharData(const string &theData) {}

public:
	friend istream &operator>>(istream &in, XMLReader &me);

	XMLReader(bool newStripWhite = false);
	virtual ~XMLReader();
};

}

#endif
